/***************************************************************************
                          credits.cpp  -  description
                             -------------------
    begin                : Tue Mar 02 2004
    copyright            : (C) 2004 by Thomas Friedrichsmeier
    email                : tfry@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CREDITS_H
#define CREDITS_H

#include "timedobject.h"
#include "tpbase.h"

#include "taxipilot.h"

#include <qstring.h>
#include <qmap.h>
#include <qvaluelist.h>

/**
This class provides the credits shown on the start-screen.

@author Thomas Friedrichsmeier
*/
class Credits : public TimedObject, public TPBase {
public:
    Credits (const QString & mission_title, const QString & mission_author, const Taxipilot::Taxis & taxis, const Taxipilot::Passengers & passengers, const QValueList<Taxipilot::LevelHandle> & levels);

    ~Credits ();
private:
	struct CreditItem {
		int width;
		int y;
		int space_to_next;
		QCanvasItem *item;
	// Allow line-break after this item (for future use)
		bool allow_break;
	};
	typedef QValueList <CreditItem*> CreditsList;
	CreditsList credits;
	CreditsList::iterator first_visible;
	CreditsList::iterator last_visible;

/** Append a sprite to the credits. Spacing after this item in pixels.
If allow break, the next item may appear in a separate line (for future use).
This function is only ever needed by generate_credits */
	void appendCreditSprite (AnimatedSprite * item, int space_after, bool allow_break);
/** See above. Append a text. */
	void appendCreditText (const QString & text, const QFont &font, int space_after, bool allow_break);
/** See above. Internal function */
	void appendCredit (CreditItem * item);

protected:
	void timerTick (int id);
};

#endif
